/*
 *   ttyvaders     Textmode shoot'em up
 *   Copyright (c) 2002 Sam Hocevar <sam@zoy.org>
 *                 All Rights Reserved
 *
 *   $Id$
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "config.h"

#include <stdlib.h>

#include "common.h"

void draw_status(game *g)
{
    static char dots30[] = "------------------------------";
    static char dashes30[] = "==============================";

    /* Draw life jauge */
    cucul_set_color(g->cv, CUCUL_COLOR_DARKGRAY, CUCUL_COLOR_BLACK);
    cucul_putstr(g->cv, 4, 1, dots30);

    if(g->p->life > MAX_LIFE * 7 / 10)
    {
        cucul_set_color(g->cv, CUCUL_COLOR_GREEN, CUCUL_COLOR_BLACK);
    }
    else if(g->p->life > MAX_LIFE * 3 / 10)
    {
        cucul_set_color(g->cv, CUCUL_COLOR_YELLOW, CUCUL_COLOR_BLACK);
    }
    else
    {
        cucul_set_color(g->cv, CUCUL_COLOR_RED, CUCUL_COLOR_BLACK);
    }

    cucul_putstr(g->cv, 4, 1, dashes30 + (MAX_LIFE - g->p->life) * 30 / MAX_LIFE);

    cucul_set_color(g->cv, CUCUL_COLOR_WHITE, CUCUL_COLOR_BLACK);
    cucul_putstr(g->cv, 1, 1, "L |");
    cucul_putstr(g->cv, 34, 1, "|");

    /* Draw weapon jauge */
    cucul_set_color(g->cv, CUCUL_COLOR_DARKGRAY, CUCUL_COLOR_BLACK);
    cucul_putstr(g->cv, 42, 1, dots30 + 10);

    if(g->p->special > MAX_SPECIAL * 9 / 10)
    {
        cucul_set_color(g->cv, CUCUL_COLOR_WHITE, CUCUL_COLOR_BLACK);
    }
    else if(g->p->special > MAX_SPECIAL * 3 / 10)
    {
        cucul_set_color(g->cv, CUCUL_COLOR_CYAN, CUCUL_COLOR_BLACK);
    }
    else
    {
        cucul_set_color(g->cv, CUCUL_COLOR_BLUE, CUCUL_COLOR_BLACK);
    }

    cucul_putstr(g->cv, 42, 1, dashes30 + 10
                       + (MAX_SPECIAL - g->p->special) * 20 / MAX_SPECIAL);

    cucul_set_color(g->cv, CUCUL_COLOR_WHITE, CUCUL_COLOR_BLACK);
    cucul_putstr(g->cv, 39, 1, "S |");
    cucul_putstr(g->cv, 62, 1, "|");
}

